<template>
	<GridLayout class="input-area" rows="30, auto" marginBottom="5">
		<Label ref="label" row="1" :text="placeholder" opacity="0.4" fontSize="18" class="input" padding="10" />
		<TextField ref="textField" :secure="secure" :text="value" row="1" @focus="onFocus" @blur="onBlur" padding="10" @textChange="emitTextChange"/>
	</GridLayout>
</template>

<script>
import { Color } from "color";
export default {
  props: {
    placeholder: {
      type: String
    },
    secure: {
      type: String
    },
    editable: {
      type: String
    },
    value: {
      type: String
    }
  },
  methods: {
    emitTextChange: function(event) {
      this.$emit('input', event.value)
    },
    onFocus: function() {
      // get our elments to maninpulate.
      const label = this.$refs.label.nativeView;
      const textField = this.$refs.textField.nativeView;

      // animate the label sliding up and less transparent.
      label
        .animate({
          translate: { x: 0, y: -40 },
          opacity: 1,
          color: new Color("#ffffff")
        })
        .then(() => {}, () => {});
      label.padding = 10;
      // set the border bottom color to green to indicate focus
      textField.borderBottomWidth = 3;
      // textField.animate({

      // })
      textField.borderBottomColor = new Color("#00b47e");
    },
    onBlur: function() {
      const label = this.$refs.label.nativeView;
      const textField = this.$refs.textField.nativeView;

      // if there is text in our input then don't move the label back to it's initial position.
      if (!textField.text) {
        label
          .animate({
            translate: { x: 0, y: 0 },
            opacity: 0.4,
            padding: 0,
            color: new Color("#ffffff")
          })
          .then(() => {}, () => {});
      }
      // reset border bottom color.
      textField.borderBottomWidth = 0;
    }
  }
};
</script>

<style scoped>
label {
  color: #000000;
  z-index: 99px;
}
TextField {
  color: #000000;
  box-shadow: 0px 2px 4px rgba(0, 0, 0, 0.25);
  border-radius: 10px;
  background: #ffffff;
  box-shadow: 0px 2px 4px rgba(0, 0, 0, 0.25);
}
.input-area {
  margin: 50px;
}
</style>
